/// <reference types="node" />
import { CookieSerializeOptions } from "cookie";
import type { IncomingMessage, ServerResponse } from "http";
declare type password = string | {
    id: number;
    password: string;
}[];
export interface IronSessionOptions {
    cookieName: string;
    password: password;
    ttl?: number;
    cookieOptions?: CookieSerializeOptions;
}
export interface IronSession {
    set: <T = any>(name: string, value: T) => T;
    get: <T = any>(name: string) => T | undefined;
    unset: (name: string) => void;
    destroy: () => void;
    save: () => Promise<string>;
}
export declare function getIronSession<RequestType extends IncomingMessage, ResponseType extends ServerResponse>(req: RequestType, res: ResponseType, userOptions: IronSessionOptions): Promise<{
    set: <T = any>(name: string, value: T) => T;
    get: (name?: string | undefined) => any;
    unset: (name: string) => void;
    save(): Promise<string>;
    destroy(): void;
}>;
export {};
