import type { GetServerSidePropsContext, GetServerSidePropsResult, NextApiRequest, NextApiResponse } from "next";
import type { IronSession, IronSessionOptions } from "./";
export interface NextApiRequestWithIronSession extends NextApiRequest {
    session: IronSession;
}
export declare type NextApiHandlerWithIronSession<T = any> = (req: NextApiRequestWithIronSession, res: NextApiResponse<T>) => void | Promise<void>;
interface NextGetSeverSideContextWithIronSession extends GetServerSidePropsContext {
    req: NextApiRequestWithIronSession;
}
export declare type NextGetServerSidePropsHandlerWithIronSession<P> = (context: NextGetSeverSideContextWithIronSession) => Promise<GetServerSidePropsResult<P>>;
export declare function withIronSessionApiRoute(handler: NextApiHandlerWithIronSession, options: IronSessionOptions): NextApiHandlerWithIronSession;
export declare function withIronSessionSsr<P>(handler: NextGetServerSidePropsHandlerWithIronSession<P>, options: IronSessionOptions): NextGetServerSidePropsHandlerWithIronSession<P>;
export {};
